﻿using Benday.TfsUtility.JsonMessageTypes;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Benday.TfsUtility.Tests
{

    public static class JsonMessageTypeUtility
    {
        
        public static void AssertBuildDefinitionInfoIsPopulated(BuildDefinitionInfo actual)
        {
            Assert.IsNotNull(actual);
            
            AssertINamedIsPopulated(actual);

            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.Quality, "Quality");
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.Uri, "Uri");
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.Url, "Url");
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.ItemType, "ItemType");
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.Revision, "Revision");
            
            AssertPersonInfoIsPopulated(actual.AuthoredBy);
            
            AssertProjectInfoIsPopulated(actual.Project);
        }
        private static void AssertPersonInfoIsPopulated(PersonInfo actual)
        {
            Assert.IsNotNull(actual);
            AssertINamedIsPopulated(actual);
            
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.Url, "Url");
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.ImageUrl, "ImageUrl");
        }

        private static void AssertProjectInfoIsPopulated(ProjectInfo actual)
        {
            Assert.IsNotNull(actual);
            AssertINamedIsPopulated(actual);
            
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.Url, "Url");
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.State, "State");
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.Revision, "Revision");
        }

        private static void AssertINamedIsPopulated(INamed actual)
        {
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.Id, "Id");
            UnitTestUtility.AssertIsNotNullOrEmptyString(actual.Name, "Name");
        }
    }
}
