using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Linq;

namespace Benday.TfsUtility.JsonMessageTypes
{
    public class BuildDefinitionForUploadModified
    {
        public BuildDefinitionForUploadModified()
        {
            ItemType = "build";
            Quality = "definition";
            Queue = new BuildQueueId() { Id = "1" };
            Build = new JArray();
        }


        [JsonProperty("id")]
        public string Id { get; set; }


        [JsonProperty("revision")]
        public string Revision { get; set; }

        [JsonProperty("name")]
        public string Name { get; set; }

        [JsonProperty("definitionType")]
        public string ItemType { get; set; }

        [JsonProperty("documentQuality")]
        public string Quality { get; set; }

        [JsonProperty("queue")]
        public BuildQueueId Queue { get; set; }

        public class BuildQueueId
        {
            [JsonProperty("id")]
            public string Id { get; set; }
        }

        [JsonProperty("build")]
        public JToken Build { get; set; }


        [JsonProperty("repository")]
        public JToken Repository { get; set; }


        [JsonProperty("options")]
        public JToken Options { get; set; }


        [JsonProperty("variables")]
        public JToken Variables { get; set; }


        [JsonProperty("triggers")]
        public JToken Triggers { get; set; }


        [JsonProperty("comment")]
        public string Comment { get; set; }
    }
}
