﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.Serialization;

namespace Benday.TfsUtility
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length == 0)
            {
                DisplayUsage();
            }
            else
            {
                try
                {
                    string commandName = args[0];

                    if (commandName == TfsUtilityConstants.CommandArgumentNameListWorkItemQueryFolders)
                    {
                        new WorkItemQueryFolderListCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameBuildDefinitionsList)
                    {
                        new BuildDefinitionListCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameReleaseDefinitionsList)
                    {
                        new ReleaseDefinitionListCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameReleaseDefinitionExport)
                    {
                        new ReleaseDefinitionExportCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameReleaseDefinitionImport)
                    {
                        new ReleaseDefinitionImportCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameBuildDefinitionExport)
                    {
                        new BuildDefinitionExportCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameBuildDefinitionImport)
                    {
                        new BuildDefinitionImportCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameListWorkItemQueries)
                    {
                        new WorkItemQueryListCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameWorkItemQueryExport)
                    {
                        new WorkItemQueryExportCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameWorkItemQueryImport)
                    {
                        new WorkItemQueryImportCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameTeamProjectList)
                    {
                        new TeamProjectListCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameListIterations)
                    {
                        new ListIterationsCommand(args).Run();
                    }
                    else if (commandName == TfsUtilityConstants.CommandArgumentNameAddIteration)
                    {
                        new AddIterationCommand(args).Run();
                    }
                    else
                    {
                        DisplayUsage();
                    }
                }
                catch(MissingArgumentException)
                {
                    
                }
                catch(Exception ex)
                {
                    Console.WriteLine(ex.ToString());
                }  
                /* 
                finally
                {
                    Console.WriteLine("Press ENTER to exit...");
                    Console.ReadLine();
                }  
                */              
            }           
        }

        private static void DisplayUsage()
        {
            string indent = "\t";

            StringBuilder builder = new StringBuilder();

            builder.AppendLine();
            builder.AppendLine("Team Foundation Server Utility");
            builder.AppendLine("Benjamin Day Consulting, Inc.");
            builder.AppendLine("www.benday.com");
            builder.AppendLine();
            builder.AppendLine("Available commands:");
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameTeamProjectList);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameListWorkItemQueryFolders);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameListWorkItemQueries);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameWorkItemQueryExport);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameWorkItemQueryImport);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameListIterations);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameAddIteration);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameBuildDefinitionsList);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameBuildDefinitionExport);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameBuildDefinitionImport);

            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameReleaseDefinitionsList);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameReleaseDefinitionExport);
            builder.AppendLine(indent + TfsUtilityConstants.CommandArgumentNameReleaseDefinitionImport);

            Console.WriteLine(builder.ToString());
        }
    }
}
